<template>
  <div class="w-full h-16 flex px-1 py-2 bg-surface border-opacity-100 border-b border-b-[#767680]">
    <!-- Go back button -->
    <svn-pro-icon-button
      v-if="hasLeftContent"
      data-testid="back-button"
      :variant="ButtonVariants.text"
      :color="theme.current.value.colors.onSurfaceVariant"
      icon="custom:mingcute:arrow-left-line"
      @click="emit('onBack')"
    />

    <div
      v-if="hasRightContent"
      class="w-full flex flex-1 justify-end items-center gap-2"
    >
      <!-- Info Tag -->
      <svn-pro-info-tag
        v-if="hasInfoTag"
        :tag-type="InfotagTypes.info"
        :tag-style="InfotagStyles.filled"
        :tag-size="infoTagSize"
        :text="infoTagText"
        break-all
      />

      <!-- Icon buttons -->
      <div
        v-if="iconButtonsNumber >= 1"
        class="flex gap-2 justify-center"
      >
        <svn-pro-icon-button
          v-for="iconButton in iconButtonsArray.slice(0, iconButtonsNumber)"
          :variant="ButtonVariants.text"
          :color="iconButton?.color ? iconButton?.color : theme.current.value.colors.onSurfaceVariant"
          :icon="iconButton?.icon"
          @click="iconButton?.onClick"
        />
      </div>

      <!-- Secondary Button -->
      <svn-pro-button
        v-if="hasSecondaryButton"
        data-testid="secondary-button"
        :variant="ButtonVariants.outlined"
        :prepend-icon="secondaryButtonIcon"
        :text="secondaryButtonText"
        :loading="secondaryButtonLoading"
        :disabled="secondaryButtonDisabled"
        @click="emit('onSecondaryClick')"
      />

      <!-- Primary Button -->
      <svn-pro-button
        v-if="hasPrimaryButton"
        data-testid="primary-button"
        :variant="ButtonVariants.flat"
        :prepend-icon="primaryButtonIcon"
        :text="primaryButtonText"
        :loading="primaryButtonLoading"
        :disabled="primaryButtonDisabled"
        @click="emit('onPrimaryClick')"
      />

      <!-- Close button -->
      <svn-pro-icon-button
        v-if="hasCloseButton"
        data-testid="close-button"
        :variant="ButtonVariants.text"
        :color="theme.current.value.colors.onSurfaceVariant"
        icon="custom:mingcute:close-line"
        @click="emit('onClose')"
      />
    </div>
  </div>
</template>

<script setup>
import {
  InfotagTypes,
  InfotagStyles,
  ComponentSizes,
  ButtonVariants,
} from "../../constants/types.js";
import { useTheme } from 'vuetify';
import SvnProInfoTag from "../chip/SvnProInfoTag.vue";
import SvnProButton from "../../components/button/SvnProButton.vue";
import SvnProIconButton from "../../components/button/SvnProIconButton.vue";

const theme = useTheme();

const props = defineProps({
  hasRightContent: { type: Boolean, default: true },
  hasLeftContent: { type: Boolean, default: true },
  hasCloseButton: { type: Boolean, default: true },
  iconButtonsNumber: { type: Number, default: 0, validator: (value) => Number.isFinite(value) && value >= 0 },
  iconButtonsArray: { type: Array, default: () => [], validator: (value) => Array.isArray(value) && value.every(item => typeof item === 'object') },
  hasPrimaryButton: { type: Boolean, default: true },
  primaryButtonIcon: { type: String, default: undefined },
  primaryButtonText: { type: String, default: undefined },
  primaryButtonLoading: { type: Boolean, default: false },
  primaryButtonDisabled: { type: Boolean, default: false },
  hasSecondaryButton: { type: Boolean, default: true },
  secondaryButtonIcon: { type: String, default: undefined },
  secondaryButtonText: { type: String, default: undefined },
  secondaryButtonLoading: { type: Boolean, default: false },
  secondaryButtonDisabled: { type: Boolean, default: false },
  hasInfoTag: { type: Boolean, default: true },
  infoTagText: { type: String, default: undefined },
  infoTagSize: { type: String, default: ComponentSizes.default },
});

const emit = defineEmits([
  'onBack',
  'onClose',
  'onPrimaryClick',
  'onSecondaryClick',
]);
</script>